"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var lib_1 = require("@nano-sql/core/lib");
var plugin_db_1 = require("../../../persistence/plugin-db");
var model_1 = require("./model");
var RecognizersStateStoreDb = (function () {
    function RecognizersStateStoreDb() {
        this.tableName = model_1.recognizersStateModel.name;
    }
    RecognizersStateStoreDb.prototype.isActive = function (recognizer) {
        return __awaiter(this, void 0, void 0, function () {
            var rows;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, plugin_db_1.pluginDb.createDB()];
                    case 1:
                        _a.sent();
                        return [4, lib_1.nSQL(this.tableName)
                                .query("select")
                                .where(["id", "=", recognizer])
                                .exec()];
                    case 2:
                        rows = _a.sent();
                        if (rows.length === 0) {
                            return [2, false];
                        }
                        return [2, rows[0].active];
                }
            });
        });
    };
    RecognizersStateStoreDb.prototype.markAsActive = function (recognizer) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.updateStatus(recognizer, true)];
                    case 1:
                        _a.sent();
                        return [2];
                }
            });
        });
    };
    RecognizersStateStoreDb.prototype.markAsInactive = function (recognizer) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.updateStatus(recognizer, false)];
                    case 1:
                        _a.sent();
                        return [2];
                }
            });
        });
    };
    RecognizersStateStoreDb.prototype.getLastActivity = function (recognizer) {
        return __awaiter(this, void 0, void 0, function () {
            var rows, lastActivity;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, plugin_db_1.pluginDb.createDB()];
                    case 1:
                        _a.sent();
                        return [4, lib_1.nSQL(this.tableName)
                                .query("select")
                                .where(["id", "=", recognizer])
                                .exec()];
                    case 2:
                        rows = _a.sent();
                        if (rows.length === 0) {
                            return [2, null];
                        }
                        lastActivity = rows[0].lastActivity;
                        return [2, lastActivity ? lastActivity : null];
                }
            });
        });
    };
    RecognizersStateStoreDb.prototype.updateLastActivity = function (recognizer, activity) {
        return __awaiter(this, void 0, void 0, function () {
            var isActive;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, plugin_db_1.pluginDb.createDB()];
                    case 1:
                        _a.sent();
                        return [4, this.isActive(recognizer)];
                    case 2:
                        isActive = _a.sent();
                        if (!isActive) {
                            return [2, null];
                        }
                        return [4, lib_1.nSQL(this.tableName + ".lastActivity")
                                .query("upsert", activity)
                                .where(["id", "=", recognizer])
                                .exec()];
                    case 3:
                        _a.sent();
                        return [2];
                }
            });
        });
    };
    RecognizersStateStoreDb.prototype.updateStatus = function (recognizer, active) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, plugin_db_1.pluginDb.createDB()];
                    case 1:
                        _a.sent();
                        return [4, lib_1.nSQL(this.tableName)
                                .query("upsert", { id: recognizer, active: active, lastActivity: null })
                                .exec()];
                    case 2:
                        _a.sent();
                        return [2];
                }
            });
        });
    };
    return RecognizersStateStoreDb;
}());
exports.recognizersStateStoreDb = new RecognizersStateStoreDb();
//# sourceMappingURL=store.js.map